function ZAMB_Core(%miniGame) {
	%obj = new ScriptObject() {
		class = ZAMB_Core;
		miniGame = %miniGame;
	};

	MissionCleanup.add(%obj);
	return %obj;
}

function ZAMB_Core::onAdd(%this) {
	if ($Pref::Server::ZAMBDebug) {
		echo("ZAMB_Core(" @ %this @ ")::onAdd");
	}

	if (%this.difficulty $= "") {
		%this.difficulty = $Pref::Server::ZAMBDifficulty;

		if (%this.difficulty $= "") {
			%this.difficulty = 1;
		}
	}

	%this.sound = ZAMB_Sound(%this);
	%this.zombies = ZAMB_Zombies(%this);
	%this.director = ZAMB_Director(%this);

	%this.tick = %this.schedule(0, tick);
}

function ZAMB_Core::onRemove(%this) {
	if ($Pref::Server::ZAMBDebug) {
		echo("ZAMB_Core(" @ %this @ ")::onRemove");
	}

	%this.sound.delete();
	%this.zombies.delete();
	%this.director.delete();
}

function ZAMB_Core::tick(%this) {
	cancel(%this.tick);

	if (%this.ended) {
		return;
	}

	%this.director.tick();
	%this.zombies.tick();
	%this.sound.tick();

	%this.tick = %this.schedule(100, tick);
}

function ZAMB_Core::end(%this, %message) {
	if ($Pref::Server::ZAMBDebug) {
		echo("ZAMB_Core(" @ %this @ ")::end()");
	}

	if (%this.ended) {
		return;
	}

	%this.ended = 1;
	%this.zombies.stop();

	cancel(%this.tick);

	for (%i = 0; %i < %this.miniGame.numMembers; %i++) {
		%client = %this.miniGame.member[%i];

		if (%message !$= "") {
			messageClient(%client, '', %message);
		}

		%player = %client.player;

		if (isObject(%player) && %player.getState() !$= "Dead") {
			%client.camera.setMode("Corpse", %player);
			%client.setControlObject(%client.camera);
		}
	}

	%this.miniGame.schedule(10000, "reset", 0);
}
