datablock PlayerData(BoomerZombieData : ZombieData) {
	zombieType = 2;
	hasFootsteps = 0; // 1
};

function BoomerZombieData::onAdd(%this, %obj) {
	ZombieData::onAdd(%this, %obj);
}

function BoomerZombieData::onRemove(%this, %obj) {
	ZombieData::onRemove(%this, %obj);
}

function BoomerZombieData::onDisabled(%this, %obj) {
	%hack = %obj.getHackPosition();
	initContainerRadiusSearch(%hack, 6, $TypeMasks::PlayerObjectType);

	while (isObject(%col = containerSearchNext())) {
		if (%col.getDataBlock().isSurvivor) {
			%distance = vectorDist(%hack, %col.getHackPosition());

			if (%distance <= 6) {
				%col.applyBoomerVomit();
			}
		}
	}

	%profile = "zamb_boomer_explode" @ getRandom(1, 3);

	if (isObject(%profile)) {
		serverPlay3D(%profile, %obj.getHackPosition());
	}

	%obj.spawnExplosion(spawnProjectile, 2);
	parent::onDisabled(%this, %obj);
}

function BoomerZombieData::onReachDestination(%this, %obj) {
	ZombieData::onReachDestination(%this, %obj);
}

function BoomerZombieData::applyZombieAppearance(%this, %obj) {
	ZombieData::applyZombieAppearance(%this, %obj);
	%obj.setScale("1.3 1.6 1");
}

function BoomerZombieData::zombieAttack(%this, %obj) {
	ZombieData::zombieAttack(%this, %obj);
}

function BoomerZombieData::updateAI(%this, %obj) {
	ZombieData::updateAI(%this, %obj);
}

function BoomerZombieData::updateTarget(%this, %obj) {
	ZombieData::updateTarget(%this, %obj);
}

function BoomerZombieData::getTargetScore(%this, %obj, %target) {
	return ZombieData::getTargetScore(%this, %obj, %target);
}

function BoomerZombieData::directMovement(%this, %obj) {
	return ZombieData::directMovement(%this, %obj);
}

function BoomerZombieData::pathedMovement(%this, %obj) {
	return ZombieData::pathedMovement(%this, %obj);
}

function BoomerZombieData::shouldStrafe(%this, %obj, %dist) {
	return ZombieData::shouldStrafe(%this, %obj, %dist);
}

function BoomerZombieData::shouldJump(%this, %obj, %dist) {
	return ZombieData::shouldJump(%this, %obj, %dist);
}

function BoomerZombieData::shouldCrouch(%this, %obj, %dist) {
	return ZombieData::shouldCrouch(%this, %obj, %dist);
}

function player::applyBoomerVomit(%this) {
	if (!%this.isBoomerVictim()) {
		%this.lastBoomerVictimTime = $Sim::Time;

		if (isObject(%this.client)) {
			%this.client.updateZAMBDisplay();
			// %this.client.play2D(zamb_music_pukricide);
		}

		%miniGame = getMiniGameFromObject(%this);

		if (isObject(%miniGame.zamb) && !%miniGame.zamb.ended) {
			if ($Sim::Time - %miniGame.zamb.director.prevHorde >= 0.5) {
				%miniGame.zamb.director.horde(1);
			}
		}
	}
}

function player::isBoomerVictim(%this) {
	return $Sim::Time - %this.lastBoomerVictimTime < 15;
}
