datablock PlayerData(WandererZombieData : ZombieData) {
	zombieType = 0;
};

function WandererZombieData::onAdd(%this, %obj) {
	ZombieData::onAdd(%this, %obj);
	%obj.isWandering = 1;

	%obj.setMoveTolerance(1.25);
	%obj.setMoveSpeed(0.25);

	%obj.maxYawSpeed = 4;
	%obj.maxPitchSpeed = 3;
}

function WandererZombieData::onRemove(%this, %obj) {
	ZombieData::onRemove(%this, %obj);
}

function WandererZombieData::onReachDestination(%this, %obj) {
	ZombieData::onReachDestination(%this, %obj);
}

function WandererZombieData::applyZombieAppearance(%this, %obj) {
	ZombieData::applyZombieAppearance(%this, %obj);
}

function WandererZombieData::updateAI(%this, %obj) {
	ZombieData::updateAI(%this, %obj);
}

function WandererZombieData::zombieAttack(%this, %obj) {
	if (!%obj.isWandering) {
		ZombieData::zombieAttack(%this, %obj);
	}
}

function WandererZombieData::updateTarget(%this, %obj) {
	if (!%obj.isWandering) {
		ZombieData::updateTarget(%this, %obj);
		return;
	}

	if (%obj.target !$= "") {
		return;
	}

	initContainerRadiusSearch(%obj.position, 10, $TypeMasks::StaticShapeObjectType);

	while (isObject(%shape = containerSearchNext())) {
		if (isObject(%shape.node)) {
			%nodes = trim(%nodes SPC %shape.node);
		}
	}

	if (%nodes !$= "") {
		%index = getRandom(0, getWordCount(%nodes) - 1);
		%obj.target = getWord(%nodes, %index);
	}
}

function WandererZombieData::getTargetScore(%this, %obj, %target) {
	return ZombieData::getTargetScore(%this, %obj, %target);
}

function WandererZombieData::directMovement(%this, %obj) {
	return ZombieData::directMovement(%this, %obj);
}

function WandererZombieData::pathedMovement(%this, %obj) {
	return ZombieData::pathedMovement(%this, %obj);
}

function WandererZombieData::shouldStrafe(%this, %obj, %dist) {
	%strafe = ZombieData::shouldStrafe(%this, %obj, %dist);

	if (%obj.isWandering) {
		%strafe *= 0.25;
	}

	return %strafe;
}

function WandererZombieData::shouldJump(%this, %obj, %dist) {
	return ZombieData::shouldJump(%this, %obj, %dist);
}

function WandererZombieData::shouldCrouch(%this, %obj, %dist) {
	return ZombieData::shouldCrouch(%this, %obj, %dist);
}

function WandererZombieData::zombieStopWandering(%this, %obj) {
	if (!%obj.isWandering) {
		return;
	}

	%obj.isWandering = 0;
	%obj.target = "";

	%obj.maxYawSpeed = 8;
	%obj.maxPitchSpeed = 6;

	%obj.setMoveTolerance(0.75);
	%obj.setMoveSpeed(1);
}

function WandererZombieData::damage(%this, %obj, %src, %loc, %damage, %type) {
	%this.zombieStopWandering(%obj);
	parent::damage(%this, %obj, %src, %damage, %type);

	initContainerRadiusSearch(%loc, 24, $TypeMasks::PlayerObjectType);

	while (isObject(%col = containerSearchNext())) {
		if (%col.getDataBlock() == %this && %col.isWandering) {
			%this.zombieStopWandering(%col);
		}
	}
}
